// DiscImageDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DiscImage.h"
#include "DiscImageDlg.h"
#include "MIDI2COB.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDiscImageDlg dialog

CDiscImageDlg::CDiscImageDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDiscImageDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDiscImageDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDiscImageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDiscImageDlg)
	DDX_Control(pDX, IDC_PROGRESS1, m_Progress);
	DDX_Control(pDX, IDC_LIST1, m_listFiles);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDiscImageDlg, CDialog)
	//{{AFX_MSG_MAP(CDiscImageDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_COMMAND(ID_FILE_ADDFILES, OnFileAddfiles)
	ON_BN_CLICKED(IDCREATEIMAGE, OnCreateimage)
	ON_BN_CLICKED(IDREMOVE, OnRemove)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDiscImageDlg message handlers

BOOL CDiscImageDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDiscImageDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDiscImageDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDiscImageDlg::OnFileExit() 
{
	PostQuitMessage(0);	
}

void CDiscImageDlg::FillList(CString path, const char* filter)
{
	WIN32_FIND_DATA finfo;
	HANDLE cur;

	if ((cur = FindFirstFile(filter, &finfo)) != INVALID_HANDLE_VALUE)
	{
		while (FindNextFile(cur,&finfo))
		{
			m_listFiles.AddString(path + finfo.cFileName);
		}

		FindClose(cur);
	}
}

void CDiscImageDlg::OnFileAddfiles() 
{
	CFileDialog file(TRUE);
	char fileName[256] = "All file";
	file.m_ofn.lpstrFilter = "Karaoke File (*.kar)\0*.kar\0MIDI File (*.mid)\0*.mid";
	file.m_ofn.lpstrFile = fileName;
	file.m_ofn.nMaxFile = 256;
	if (file.DoModal() == IDOK)
	{
		CString filter = file.GetPathName();
		CString path = filter.Left(filter.GetLength() - 8);
		FillList(path, (LPCTSTR)(path + "*.mid"));
	}
}

void CDiscImageDlg::OnCreateimage() 
{
	int numFiles = m_listFiles.GetCount();
	int byteWritten = 0;

	m_Progress.SetRange(0, 99);
	m_Progress.SetPos(0);

	FILE* fp = fopen("DTSMUS00.DKD", "wb");// Limit to 1 file for now

	// Write header
	unsigned char* header1 = new unsigned char[0x200];
	memset(header1, 0, 0x200);
	header1[0x02] = 0xC2;
	header1[0x03] = 0x21;
	header1[0x07] = 0x01;
	header1[0x0B] = 0x01;
	header1[0x0F] = 0x02;
	header1[0x13] = 0x01;
	byteWritten += fwrite(header1, 1, 0x200, fp);
	delete[] header1;

	unsigned int* tableOfTables = new unsigned int[384];
	memset(tableOfTables, 0, 384 * sizeof(int));

	// Write an empty table first, and we'll have to populate it later
	byteWritten += fwrite(tableOfTables, 1, 384 * sizeof(int), fp);

	unsigned int* tableOfSongs = new unsigned int[512];
	unsigned int  tableOfSongsOffset = 0;

	for (int i = 0; i < numFiles; i++)
	{
		if ((i % 256) == 0)
		{
			// Update the previous table
			if (i != 0)
			{
				fseek(fp, tableOfSongsOffset, SEEK_SET);
				correctEndian(tableOfSongs, 512);
				fwrite(tableOfSongs, 1, 512 * sizeof(int), fp);
				fseek(fp, byteWritten, SEEK_SET);
			}

			memset(tableOfSongs, 0, 512 * sizeof(int));

			// Write the table of songs, empty
			tableOfSongsOffset = byteWritten;
			tableOfTables[i % 256] = byteWritten / 0x800;
			byteWritten += fwrite(tableOfSongs, 1, 512 * sizeof(int), fp);
		}

		CString fileName;
		m_listFiles.GetText(i, fileName);

		tableOfSongs[i % 256] = byteWritten - tableOfSongsOffset;
		int songSize = midi2Cob((char*)(LPCTSTR)fileName, fp);
		tableOfSongs[256 + (i % 256)] = songSize / 1472;// weird scale
		byteWritten += songSize;

		m_Progress.SetPos((i + 1) * 100 / numFiles);
	}

	// Update the last table of song
	fseek(fp, tableOfSongsOffset, SEEK_SET);
	correctEndian(tableOfSongs, 512);
	fwrite(tableOfSongs, 1, 512 * sizeof(int), fp);

	// Update the table of tables
	fseek(fp, 0x200, SEEK_SET);
	correctEndian(tableOfTables, 384);
	fwrite(tableOfTables, 1, 384 * sizeof(int), fp);

	delete[] tableOfSongs;
	delete[] tableOfTables;

	fclose(fp);
}

void CDiscImageDlg::OnRemove() 
{
	int size = m_listFiles.GetCount();
	LPINT selectedItems = new INT[size];
	int actualSelectedItems;
	
	while ((actualSelectedItems = m_listFiles.GetSelItems(size, selectedItems)) > 0)
	{
		m_listFiles.DeleteString(selectedItems[0]);
	}
	delete[] selectedItems;
}
